/*
 * Dustin Germain
 * Make Course Project "Rover"
 * 10/25/2015
 */
 
#include <Servo.h>
#include <IRremote.h>

Servo LeftDriveFront;
Servo LeftDriveRear;
Servo RightDriveFront;
Servo RightDriveRear;
Servo LeftTurnRear;
Servo LeftTurnFront;
Servo RightTurnRear;
Servo RightTurnFront;
Servo headSweep;

int LftDrvFrntPin = 11;
int LftTrnFrntPin = 10;
int LftTrnRrPin = 12;
int LftDrvRrPin = 13;
int RtDrvFrntPin = 7;
int RtTrnRrPin = 8;
int RtTrnFrntPin = 6;
int RtDrvRrPin = 9;
int IRpin = 2;// IR sensor
int pos = 75;//store servo start position 
int counter = 0;
bool sweep = 0;
bool direction1 = 0;

#define echoPin 14 
#define triggerPin 15

IRrecv irrecv(IRpin);
decode_results results;

void setup()
{
irrecv.enableIRIn(); // Start IR receiver
   
 /********Sets Turing Servos in the forward position**********/  
 LeftTurnFront.write(97);
 LeftTurnRear.write(81);
 RightTurnFront.write(139);
 RightTurnRear.write(85);
 
/*********Sets Drive Servos to Neutral Position**********/
  LeftDriveFront.write(89);
  LeftDriveRear.write(88);
  RightDriveFront.write(66);
  RightDriveRear.write(69);
  
/*********Attaching Servos to Aruino Pins**********/   
   LeftDriveFront.attach(LftDrvFrntPin);
   LeftTurnFront.attach(LftTrnFrntPin);
   LeftTurnRear.attach(LftTrnRrPin);
   LeftDriveRear.attach(LftDrvRrPin);
   RightDriveFront.attach(RtDrvFrntPin);
   RightTurnRear.attach(RtTrnRrPin);
   RightTurnFront.attach(RtTrnFrntPin);
   RightDriveRear.attach(RtDrvRrPin);
   headSweep.attach(3);
   
/*********For Head Sweep**********/
  pinMode(5,OUTPUT);//green LED
  digitalWrite(5,HIGH);
  pinMode(echoPin, INPUT);
  pinMode(triggerPin, OUTPUT);
  pinMode(16,OUTPUT);//piezo buzzer
  digitalWrite(16,LOW);
  pinMode(4,OUTPUT);//red LED
  digitalWrite(4,LOW);
  //Serial.begin(115200);
}

void loop(){
  
         initialize();
         
    if (irrecv.decode(&results)) 
    { 
      irrecv.resume();//Receive next value
    }

    else if (results.value == 3249146358) {
       sweep=1; 
    }
 
    else if (results.value == 3249154518) {
       sweep=0;  
    }
    else if (results.value == 3249147378) {                                                  
         forward();  
         }
    else if (results.value == 3249185118) {                                                  
         stoprover();   
         }
    else if (results.value == 3249163698) {                                                  
         reverse();
         }
    else if (results.value == 3249180018) {                                                  
         turnright();
         }
    else if (results.value == 3249196338){                                                  
         turnleft();
         }
}

/*********Functions**********/
void forward()
{
  LeftDriveFront.write(180);
  LeftDriveRear.write(180);
  RightDriveFront.write(0);
  RightDriveRear.write(0);
}
void stoprover()
{
  LeftDriveFront.write(89);
  LeftDriveRear.write(88);
  RightDriveFront.write(66);
  RightDriveRear.write(69);
  LeftTurnFront.write(97);
  LeftTurnRear.write(81);
  RightTurnFront.write(139);
  RightTurnRear.write(85);
}
void reverse()
{
  LeftDriveFront.write(0);
  LeftDriveRear.write(0);
  RightDriveFront.write(180);
  RightDriveRear.write(180);
}
void turnright()
{
 LeftTurnFront.write(145);
 LeftTurnRear.write(47);
 RightTurnFront.write(101);
 RightTurnRear.write(122);
 delay(500); 
 LeftDriveFront.write(180);
 LeftDriveRear.write(180);
 RightDriveFront.write(180);
 RightDriveRear.write(180);
}
void turnleft()
{
 LeftTurnFront.write(145);
 LeftTurnRear.write(47);
 RightTurnFront.write(101);
 RightTurnRear.write(122);
 delay(500); 
 LeftDriveFront.write(0);
 LeftDriveRear.write(0);
 RightDriveFront.write(0);
 RightDriveRear.write(0);
}
void initialize()
{
  if (sweep == 1){
    if(pos>=120){
      direction1=0;
    }
      else if(pos<=45){
          direction1=1;
        }
    
    if(direction1 == 1){
      pos+=2;
      headSweep.write(pos);
      delay(15);
      readSensor(); 
    }
    else{
      pos-=2;
      headSweep.write(pos);
      delay(15);
      readSensor();
    }
  }
}

void readSensor()
{
  digitalWrite(triggerPin, HIGH);//pulses sensor in 10micro sec bursts
  delayMicroseconds(10);
  digitalWrite(triggerPin, LOW);
  int distance = pulseIn(echoPin,HIGH);  
  distance= distance/58;//the distance in [cm] is calculated by pulselength[usec]/58  
  //Serial.print(distance,DEC);// send the measurement to the serial monitor
  //Serial.println(" cm");
  if (distance  <= 35){
    digitalWrite(16,HIGH);
    counter=50;
    digitalWrite(5,LOW);
    digitalWrite(4,HIGH);      
  }
  
    else{
      if (counter!=0){
          counter--;
    }
    
     else{
      digitalWrite(16,LOW);
      digitalWrite(5,HIGH);
      digitalWrite(4,LOW);
     
    }
}
}

